/***************************************************************************
                               cmudprofile.cpp
                             -------------------
    begin                : Sat Mar 2 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmudprofile.h"

///////////////////////////////////////////////////////////////////////////////

CMudProfile::CMudProfile()
{
	m_charProfiles.setAutoDelete(true);
}

///////////////////////////////////////////////////////////////////////////////

CMudProfile::~CMudProfile()
{
}

///////////////////////////////////////////////////////////////////////////////

void CMudProfile::create()
{
	CProfile::create();
	m_profileElement.setAttribute("type", "mud");
}

///////////////////////////////////////////////////////////////////////////////

CProfile* CMudProfile::charProfile(const QString& name)
{
	if (name.isEmpty())
		return 0;
	
	return m_charProfiles[name];
}

///////////////////////////////////////////////////////////////////////////////

bool CMudProfile::addCharProfile(const QString& name, CProfile* profile)
{
	if (name.isEmpty() || profile == 0)
		return false;
		
	if (m_charProfiles.find(name))
		return false;
	
	m_charProfiles.insert(name, profile);
	return true;
}

///////////////////////////////////////////////////////////////////////////////

CProfile* CMudProfile::removeCharProfile(const QString& name)
{
	if (name.isEmpty())
		return 0;
		
	m_charProfiles.setAutoDelete(false);
	CProfile* profile = m_charProfiles.take(name);
	m_charProfiles.setAutoDelete(true);
	
	return profile;
}

///////////////////////////////////////////////////////////////////////////////

QStringList CMudProfile::characters()
{
	QStringList charList;
	QDictIterator<CProfile> it(m_charProfiles);
	
	for (it.toFirst(); it.current(); ++it)
	{
		charList.append(it.currentKey());
	}
	
	return charList;
}

// end of file
