/***************************************************************************
                               connectiontime.cpp
                             -------------------
    begin                : Mon Dec 10 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "connectiontime.h"

// Qt includes
#include <qtimer.h>

ConnectionTime::ConnectionTime(QObject* parent) :
	QObject(parent), m_second(0), m_minute(0), m_hour(0)
{
	m_timer = new QTimer();
	connect(m_timer, SIGNAL(timeout()), SLOT(slotTimeOut()));
}

ConnectionTime::~ConnectionTime()
{
	delete m_timer;
}

void ConnectionTime::start()
{
	stop();
	m_hour = 0;
	m_minute = 0;
	m_second = 0;
	
	m_timer->start(1000); // timeout 1 second
}

void ConnectionTime::stop()
{
	m_timer->stop();
}

uint ConnectionTime::elapsed()
{
	uint result = m_hour;
	result *= 60;
	result += m_minute;
	result *= 60;
	result += m_second;
	
	return result;
}

QString ConnectionTime::toString()
{
	QString result;
	result.sprintf("%02u:%02u:%02u", m_hour, m_minute, m_second);
	
	return result;
}

void ConnectionTime::slotTimeOut()
{
	m_second++;
	
	if (m_second > 59)
	{
		m_second = 0;
		m_minute++;
	}
	
	if (m_minute > 59)
	{
		m_minute = 0;
		m_hour++;
	}
	
	emit tick();
}
