/***************************************************************************
                               cprofile.h
                             -------------------
    begin                : Sat Mar 2 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CPROFILE_H
#define CPROFILE_H

// Qt includes
#include <qdom.h>

/** Base class for MUD and character profiles
  * @author Kmud Developer Team
  */

class CProfile {
public: 
	CProfile();
	virtual ~CProfile();
	
	virtual void create();
	virtual bool open(const QString& filename);
	virtual bool save();
	virtual bool saveAs(const QString& filename);
	const QString& filename() const { return m_filename; }

	QDomElement profileElement() { return m_profileElement; }
	
protected:
	QString m_filename;
	QDomElement m_profileElement;
	QDomDocument m_doc;
};

#endif
