/***************************************************************************
                               dlgconfig.h
                             -------------------
    begin                : Wed Jun 26 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGCONFIG_H
#define DLGCONFIG_H

#include <qwidget.h>
#include <qwidgetstack.h>
#include <qlayout.h>
#include <qptrlist.h>

#include "dlgconfigbase.h"


class KmudCore;
class KmudSetupPane;

/**
  *@author Kmud Developer Team
  */

class DlgConfig : public DlgConfigBase
{
Q_OBJECT
public:
	DlgConfig(KmudCore *core,QString title,QWidget *parent=0);
	~DlgConfig();

protected:
	void slotDefault();
	void slotAccept();
	void slotCancel();
	void slotPaneSelected(QListViewItem *item);

	virtual void addKmudPanes()=0;
	virtual void addPluginPanes()=0;
	
	void addPane(KmudSetupPane *pane);
	void populateListView();


protected:
	QWidgetStack *m_widgets;
	KmudCore *m_core;

private:
	QString getGroup(QListViewItem *item);
	QListViewItem *findParent(QString group);
	QGridLayout *m_grid;

	QPtrList<KmudSetupPane> *m_panels;
	QListViewItem *m_firstItem;

signals:
	void defaultClicked();
	void okClicked();
	void cancelClicked();
};

#endif
