/***************************************************************************
                               dlgcreateprofile.h
                             -------------------
    begin                : Sun Jul 14 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DLGCREATEPROFILE_H
#define DLGCREATEPROFILE_H


// Qt includes

// Kmud includes
#include <dlgcreateprofilebase.h>

// forward declarations
class QStringList;
class KConfigBase;
class ProfileAPI;

/**
  *@author Kmud Developer Team
  */

class DlgCreateProfile : public DlgCreateProfileBase  
{
   Q_OBJECT
public: 
	DlgCreateProfile(ProfileAPI* profileAPI, QWidget *parent=0, const char *name=0);
	~DlgCreateProfile();

	void setMudList(const QStringList& muds);
	void setCurrentMud(const QString& mudName);

	QString mudName() const { return m_mud; }
	QString charName() const { return m_char; }

private:
	QString m_profile;
	QString m_char;
	QString m_mud;

	ProfileAPI* m_profileAPI;

private slots:
	void accept();

	void slotProfileTypeChanged(bool on);

	void slotNameChanged(const QString& name);
};

#endif

// end of file
