/***************************************************************************
                               dlgoptiontiming.cpp
                             -------------------
    begin                : Fri Aug 2 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgoptiontiming.h"

#include <knuminput.h>
#include <qcheckbox.h>

#include "../kmudconfigcache.h"

#include "dlgoptiontimingbase.h"

DlgOptionTiming::DlgOptionTiming(KmudConfigCache *data,QString group,QWidget *parent, const char *name): KmudSetupPane(KmudSetupPane::GLOBAL,group,parent,name)
{
	m_data = data;
	addBaseDialog(new DlgOptionTimingBase(this,name));

	DlgOptionTimingBase *baseDlg = static_cast<DlgOptionTimingBase*>(getBaseDialog());

	baseDlg->m_chkAutoConnect->setChecked(m_data->autoReconnect);
	baseDlg->m_txtReconnect->setValue(m_data->autoReconnectSeconds);
	baseDlg->m_chkBlink->setChecked(m_data->outputNotificationOn);
	baseDlg->m_txtBlink->setValue(m_data->outputNotifyWaitSeconds);
	baseDlg->m_txtTimeout->setValue(m_data->connectionTimeoutSeconds);

	slotBlinkStateChanged(baseDlg->m_chkAutoConnect->isChecked());
	slotConnectStateChanged(baseDlg->m_chkBlink->isChecked());

	connect(baseDlg->m_chkAutoConnect,SIGNAL(toggled(bool)),this,SLOT(slotConnectStateChanged(bool)));
	connect(baseDlg->m_chkBlink,SIGNAL(toggled(bool)),this,SLOT(slotBlinkStateChanged(bool)));
}

DlgOptionTiming::~DlgOptionTiming()
{
}

/** This slot is called when the delfault/reset button is pressed */
void DlgOptionTiming::slotDefaultPressed()
{
	DlgOptionTimingBase *baseDlg = static_cast<DlgOptionTimingBase*>(getBaseDialog());
	baseDlg->m_chkAutoConnect->setChecked(true);
	baseDlg->m_txtReconnect->setValue(10);
	baseDlg->m_chkBlink->setChecked(true);
	baseDlg->m_txtBlink->setValue(10);
	baseDlg->m_txtTimeout->setValue(10);
}

/** This slot is called when the cancel button is pressed */
void DlgOptionTiming::slotCancelPressed()
{
}

/** This slot is called when the OK button is pressed */
void DlgOptionTiming::slotOkPressed()
{
	DlgOptionTimingBase *baseDlg = static_cast<DlgOptionTimingBase*>(getBaseDialog());
	m_data->autoReconnect = baseDlg->m_chkAutoConnect->isChecked();
	m_data->autoReconnectSeconds = baseDlg->m_txtReconnect->value();
	m_data->outputNotificationOn = baseDlg->m_chkBlink->isChecked();
	m_data->outputNotifyWaitSeconds = baseDlg->m_txtBlink->value();
	m_data->connectionTimeoutSeconds = baseDlg->m_txtTimeout->value();
}

/** This method is called when the auto connect checkbox is clicked */
void DlgOptionTiming::slotConnectStateChanged( bool on )
{
	DlgOptionTimingBase *baseDlg = static_cast<DlgOptionTimingBase*>(getBaseDialog());
	baseDlg->m_txtReconnect->setEnabled(on);
}

/** This method is called when the blink checkbox is clicked */
void DlgOptionTiming::slotBlinkStateChanged( bool on )
{
	DlgOptionTimingBase *baseDlg = static_cast<DlgOptionTimingBase*>(getBaseDialog());
	baseDlg->m_txtBlink->setEnabled(on);
}
