/***************************************************************************
                          dlgreconnect.cpp  -  description
                             -------------------
    begin                : Fri Mar 9 2001
    copyright            : (C) 2001 by KMud Development Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgreconnect.h"

#include <klocale.h>
#include <qlabel.h>

DlgReconnect::DlgReconnect(QWidget *parent, const char *name ) : DlgReconnectBase(parent,name,true)
{
	timer = new QTimer( this );
	connect( timer, SIGNAL(timeout()),this, SLOT(slotTimerDone()) );
	seconds = 10;
	timer->start( 1000, false );
}

DlgReconnect::~DlgReconnect()
{	
}

/** This is used to start the start time of the timer */
void DlgReconnect::setAutoTime(unsigned int t)
{
	QString time_string;

	seconds = t;
	time_string.sprintf(i18n("Auto reconnect in %d seconds...."),seconds);
	lblTime->setText(time_string);
}

/** This slot is called when the reconnect button is pressed */
void DlgReconnect::slotReconnectPressed()
{
	timer->stop();
 	done(1);
}

/** This slot is called when the cancel button is pressed */
void DlgReconnect::slotClosePressed()
{
	timer->stop();
	done(2);
}

/** This slot is called when the quick connect button is pressed */
void DlgReconnect::slotQuickPressed()
{
	timer->stop();
	done(3);
}

/** This slot is called when the wizard button is pressed */
void DlgReconnect::slotWizzardPressed()
{
	timer->stop();
	done(4);
}

/** This slot is called to up date the seconds count on the dialog */
void DlgReconnect::slotTimerDone()
{
	QString time_string;
	seconds--;

	if (seconds == 0)
	{
		timer->stop();
		done(1);
	}
	else
	{
	    time_string.sprintf(i18n("Auto reconnect in %d seconds...."),seconds);
		lblTime->setText(time_string);	
	}
}
