/***************************************************************************
                               kmudconnecthistory.h
                             -------------------
    begin                : Thu Jun 6 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMUDCONNECTHISTORY_H
#define KMUDCONNECTHISTORY_H

#include <qobject.h>
#include <qptrlist.h>
#include <qstringlist.h>

#include <kaction.h>
#include <kconfig.h>

class KmudMainWindow;

/**
  *@author Kmud Developer Team
  */

class KmudConnectHistory : public KListAction
{
   Q_OBJECT
public:
	KmudConnectHistory(KmudMainWindow* window,QObject *parent=0);
	~KmudConnectHistory();

	/** Used to add a conenction to the history
      * @param connection The connetion to add to the history  */
	static void addConnection(QString connection);

	static void saveEntries( KConfig* config);
	static void loadEntries( KConfig* config);
	/** Get the list of connections in the connection hisotry
	  * @return The connection list */
	static QStringList *getConnections(void);

private:
	static uint m_maxItems;
	static QStringList m_lstConnections;
	static QPtrList<KmudConnectHistory> m_instanceList;

};

#endif
