/***************************************************************************
                               kmudviewmanager.cpp
                             -------------------
    begin                : Sat Mar 24 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmudviewmanager.h"

#include <kdockwidget.h>
#include "kmuddebug.h"

#include "kmuddockwidget.h"


KmudViewManager::KmudViewManager(KParts::DockMainWindow* mainWindow, QObject* parent, const char* name)
:QObject(parent,name)
{
	m_kmudMainWindow=mainWindow;

	m_dockWidgets.clear();
	m_dockWidgets.setAutoDelete(false);
	
	kdDebug(DAREA_LIB_VIEWMANAGER) << "inserting " << m_kmudMainWindow->getMainDockWidget() << " as Kmud/Main" << endl;
	m_dockWidgets.insert("Kmud/Main", m_kmudMainWindow->getMainDockWidget());
	
}

KmudViewManager::~KmudViewManager()
{
}


void KmudViewManager::addWidget(KmudDockWidget* w, QString isGroup, DockPosition pos, QString toGroup,
                                const QPixmap& pixmap, const QString& caption, const QString& tabCaption)
{
	KDockWidget* dock;
	KDockWidget* parent;
	QString cap = (caption.isEmpty() ? QString(w->name()) : caption);
	QString tabCap = (tabCaption.isEmpty() ? QString(w->name()) : tabCaption);
	
	dock=m_kmudMainWindow->createDockWidget(w->name(),pixmap, 0, cap, tabCap);
	dock->setWidget(w);

	parent=m_dockWidgets.find(toGroup);
	kdDebug(DAREA_LIB_VIEWMANAGER) << "docking " << isGroup << " to " << toGroup << " (" << parent << ")" << endl;
	if (parent==0L)
	{
		kdDebug(DAREA_LIB_VIEWMANAGER) << toGroup << " not found. Docking to Kmud/Main instead." << endl;
		parent=m_dockWidgets.find("Kmud/Main");
	}
	dock->manualDock(parent,(KDockWidget::DockPosition)pos,50);
	m_dockWidgets.insert(isGroup,dock);

	connect (dock,SIGNAL(headerCloseButtonClicked()),w,SLOT(slotDockWindowClose()));
	connect (dock,SIGNAL(headerDockbackButtonClicked()),w,SLOT(slotDockbackClicked()));	
	connect (dock,SIGNAL(iMBeingClosed()),w,SLOT(slotWidgetBeingClosed()));
}


