/***************************************************************************
                               kmudviewmanager.h
                             -------------------
    begin                : Sat Mar 24 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMUDVIEWMANAGER_H
#define KMUDVIEWMANAGER_H

#include <qobject.h>
#include <qdict.h>
#include <kparts/dockmainwindow.h>

class KmudDockWidget;
class QPixmap;

/**
  *@author Kmud Developer Team
  */

class KmudViewManager : public QObject
{
	Q_OBJECT

public:

/** DockPosition taken from KDockWidget */
enum DockPosition
{
	DockNone   = 0,
	DockTop    = 0x0001,
	DockLeft   = 0x0002,
	DockRight  = 0x0004,
	DockBottom = 0x0008,
	DockCenter = 0x0010,
	DockDesktop= 0x0020,

	DockCorner = DockTop | DockLeft | DockRight | DockBottom,
	DockFullSite = DockCorner | DockCenter,
	DockFullDocking = DockFullSite | DockDesktop
};


	KmudViewManager(KParts::DockMainWindow* mainWindow, QObject* parent = 0L, const char* name = 0L);
	~KmudViewManager();

	 /**
		* Adds a widget to the view.
		* @param w the widget to add
		* @param isGroup the name of the group you define (e.g. Kmud/Mapper/SpeewalkList)
		* @param pos the position inside the widget you want to dock to
		* @param toGroup the parent widget you want to dock to (e.g. Kmud/Mapper)
		*
		* It is recommended to omit the last parameter when you want to dock to the main view.
		*/
	void addWidget(KmudDockWidget* w, QString isGroup, DockPosition pos, QString toGroup="Kmud/Main",
	               const QPixmap& pixmap = 0L, const QString& caption = 0L, const QString& tabCaption = 0L);

private:
	KParts::DockMainWindow* m_kmudMainWindow;
	QDict<KDockWidget> m_dockWidgets;
	
};

#endif
