/***************************************************************************
                               cmapcmdelementproperties.cpp
                             -------------------
    begin                : Wed Feb 27 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmapcmdelementproperties.h"

#include "cmapelement.h"
#include "cmapmanager.h"
#include "cmaplevel.h"
#include "cmaproom.h"

#include <kmuddebug.h>

CMapCmdElementProperties::CMapCmdElementProperties(CMapManager *mapManager,QString name,CMapElement *element) : CMapCommand(name)
{
	m_manager = mapManager;
	m_properties = new KMemConfig;
	m_properties->setGroup("Element");
	element->saveProperties(m_properties);
}

CMapCmdElementProperties::~CMapCmdElementProperties()
{
	delete m_properties;
}

void CMapCmdElementProperties::execute()
{
	int active = m_manager->getUndoActive();	
	m_manager->setUndoActive(false);

	CMapElement *elm = NULL;
	m_properties->setGroup("Element");
	elm = m_manager->findElement(m_properties);

	if (elm)
	{
		m_properties->setGroup("New");
		elm->loadProperties(m_properties);
		m_manager->changedElement(elm);
	}
	m_manager->setUndoActive(active);
}

void CMapCmdElementProperties::unexecute()
{
	int active = m_manager->getUndoActive();	
	m_manager->setUndoActive(false);

	CMapElement *elm = NULL;
	m_properties->setGroup("Element");
	elm = m_manager->findElement(m_properties);

	if (elm)
	{
		m_properties->setGroup("Old");
		elm->loadProperties(m_properties);
		m_manager->changedElement(elm);
	}
	m_manager->setUndoActive(active);
}

KMemConfig *CMapCmdElementProperties::getOrgProperties(void)
{
	m_properties->setGroup("Old");
	return m_properties;
}

KMemConfig *CMapCmdElementProperties::getNewProperties(void)
{
	m_properties->setGroup("New");
	return m_properties;
}

void CMapCmdElementProperties::setNewProperties(QString group,KMemConfig *newProperties)
{
	m_properties->setGroup("New");
	newProperties->copyTo(group,m_properties);
}

void CMapCmdElementProperties::setOldProperties(QString group,KMemConfig *oldProperties)
{
	m_properties->setGroup("Old");
	oldProperties->copyTo(group,m_properties);
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,QString orgValue,QString dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,bool orgValue,bool dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,int orgValue,int dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,QColor orgValue,QColor dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,QStringList orgValue,QStringList dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,QFont orgValue,QFont dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

/** Used to store check if the values are different and store then if they are */
void CMapCmdElementProperties::compare(QString id,QSize orgValue,QSize dialogValue)
{
	if (orgValue!=dialogValue)
	{
		m_properties->setGroup("Old");
		m_properties->writeEntry(id,orgValue);
		m_properties->setGroup("New");
		m_properties->writeEntry(id,dialogValue);
	}
}

