/***************************************************************************
                               cmapfilter.h
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CMAPFILTER_H
#define CMAPFILTER_H

#include <qptrqueue.h>

#include <kmudfilter.h>


class CMapManager;

/**This is used to process the input/output of the mud for the mapper
  *@author Kmud Developer Team
  */

class CMapFilter : public KmudFilter
{
public:
	CMapFilter(CMapManager *manager);
	~CMapFilter();

	/** This method is called with when input is sent to the mud */
	virtual QString filterInput(QString &);
	/** This method is called when output is sent to the mud */
	virtual QString filterOutput(QString&);

private:
	void executeBeforeCommand(QString &newStr,QString &command);
	void executeAfterCommand(QString &newStr,QString &command);

private:
	CMapManager *mapManager;
	QPtrQueue<QString> directionCmdQueue;
};

#endif
