/***************************************************************************
                               cmapviewmanagerbase.cpp
                             -------------------
    begin                : Tue Aug 7 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmapviewmanagerbase.h"

#include "cmapviewbase.h"
#include "cmapmanager.h"

CMapViewManagerBase::CMapViewManagerBase(CMapManager *manager,KmudViewManager::DockPosition pos,QString actionName,QString description, KActionCollection *actionCollection,QIconSet icon,QObject *parent, const char *name)
	: QObject(parent,name)
{
	action = new KAction (description,icon,0,this,SLOT(slotRequestNewView()),actionCollection,actionName);
	position = pos;
	actName = actionName;
	mapManager = manager;
}

CMapViewManagerBase::CMapViewManagerBase(CMapManager *manager,KmudViewManager::DockPosition pos,QString actionName,QString description, KActionCollection *actionCollection,QObject *parent, const char *name)
	: QObject(parent,name)
{
	action = new KAction (description,0,this,SLOT(slotRequestNewView()),actionCollection,actionName);
	actName = actionName;
	position = pos;
	mapManager = manager;
}


CMapViewManagerBase::~CMapViewManagerBase()
{
}

/** This is used to show a view */
void CMapViewManagerBase::showView(CMapViewBase *view)
{
	mapManager->addView(view);
	mapManager->getViewManager()->addWidget(view,"Kmud/Mapper/" + actName,position,"Kmud/Mapper");
	emit newViewOpened(view);
}

/** Used to set the whats this text for the view */
void CMapViewManagerBase::setWhatsThis(QString text)
{
	action->setWhatsThis(text);
}

/** Used to set the toop tip of the view */
void CMapViewManagerBase::setToolTip(QString tip)
{
	action->setToolTip(tip);
}
