/***************************************************************************
                               dlgmapcolor.cpp
                             -------------------
    begin                : Tue Jul 9 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgmapcolor.h"

#include <kcolorbutton.h>

#include <qcolor.h>

#include "dlgmapcolorbase.h"
#include "../cmapmanager.h"

#include <kmuddebug.h>

DlgMapColor::DlgMapColor(CMapManager *mapManager,QString group,QWidget *parent, const char *name) :  KmudSetupPane(KmudSetupPane::GLOBAL,group,parent,name)
{
	m_mapManager = mapManager;

	addBaseDialog(new DlgMapColorBase(this,name));	

	loadColors();
}

DlgMapColor::~DlgMapColor()
{
}

void DlgMapColor::loadColors()
{
	DlgMapColorBase *baseDlg = (DlgMapColorBase *)getBaseDialog();
	baseDlg->cmdSelected->setColor(m_mapManager->getMapData()->selectedColor);
	baseDlg->cmdLoginRoom->setColor(m_mapManager->getMapData()->loginColor);
	baseDlg->cmdDefaultText->setColor(m_mapManager->getMapData()->defaultTextColor);
	baseDlg->cmdDefaultPath->setColor(m_mapManager->getMapData()->defaultPathColor);
	baseDlg->cmdDefaultZone->setColor(m_mapManager->getMapData()->defaultZoneColor);
	baseDlg->cmdSpecialExit->setColor(m_mapManager->getMapData()->specialColor);
	baseDlg->cmdCurrentPosition->setColor(m_mapManager->getMapData()->currentColor);
	baseDlg->cmdEditMode->setColor(m_mapManager->getMapData()->editColor);
	baseDlg->cmdDefaultRoom->setColor(m_mapManager->getMapData()->defaultRoomColor);
	baseDlg->cmdLowerRoom->setColor(m_mapManager->getMapData()->lowerRoomColor);
	baseDlg->cmdLowerPath->setColor(m_mapManager->getMapData()->lowerPathColor);
	baseDlg->cmdLowerText->setColor(m_mapManager->getMapData()->lowerTextColor);
	baseDlg->cmdLowerZone->setColor(m_mapManager->getMapData()->lowerZoneColor);
	baseDlg->cmdUpperRoom->setColor(m_mapManager->getMapData()->higherRoomColor);
	baseDlg->cmdUpperPath->setColor(m_mapManager->getMapData()->higherPathColor);
	baseDlg->cmdUpperText->setColor(m_mapManager->getMapData()->higherTextColor);
	baseDlg->cmdUpperZone->setColor(m_mapManager->getMapData()->higherZoneColor);
	baseDlg->cmdBackground->setColor(m_mapManager->getMapData()->backgroundColor);
	baseDlg->cmdGrid->setColor(m_mapManager->getMapData()->gridColor);
}


/** This slot is called when the delfault/reset button is pressed */
void DlgMapColor::slotDefaultPressed()
{
	DlgMapColorBase *baseDlg = (DlgMapColorBase *)getBaseDialog();
	baseDlg->cmdBackground->setColor(QColor(201,167,55));
	baseDlg->cmdGrid->setColor(QColor(213,178,88));
	baseDlg->cmdLowerRoom->setColor(darkGray);
	baseDlg->cmdLowerZone->setColor(darkGray);
	baseDlg->cmdLowerText->setColor(darkGray);
	baseDlg->cmdDefaultRoom->setColor(QColor(192,192,192));
	baseDlg->cmdDefaultZone->setColor(QColor(192,192,192));
	baseDlg->cmdUpperRoom->setColor(white);
	baseDlg->cmdUpperZone->setColor(white);
	baseDlg->cmdUpperText->setColor(white);
	baseDlg->cmdLowerPath->setColor(darkGray);
	baseDlg->cmdDefaultPath->setColor(black);
	baseDlg->cmdUpperPath->setColor(white);
	baseDlg->cmdDefaultText->setColor(black);
	baseDlg->cmdSelected->setColor(blue);
	baseDlg->cmdSpecialExit->setColor(yellow);
	baseDlg->cmdLoginRoom->setColor(blue);
	baseDlg->cmdEditMode->setColor(red);
	baseDlg->cmdCurrentPosition->setColor(red);
}

/** This slot is called when the cancel button is pressed */
void DlgMapColor::slotCancelPressed()
{
}

/** This slot is called when the OK button is pressed */
void DlgMapColor::slotOkPressed()
{
	DlgMapColorBase *baseDlg = (DlgMapColorBase *)getBaseDialog();

	m_mapManager->getMapData()->selectedColor = baseDlg->cmdSelected->color();
	m_mapManager->getMapData()->loginColor = baseDlg->cmdLoginRoom->color();
	m_mapManager->getMapData()->defaultTextColor = baseDlg->cmdDefaultText->color();
	m_mapManager->getMapData()->defaultPathColor = baseDlg->cmdDefaultPath->color();
	m_mapManager->getMapData()->defaultZoneColor = baseDlg->cmdDefaultZone->color();
	m_mapManager->getMapData()->specialColor = baseDlg->cmdSpecialExit->color();
	m_mapManager->getMapData()->currentColor = baseDlg->cmdCurrentPosition->color();
	m_mapManager->getMapData()->editColor = baseDlg->cmdEditMode->color();
	m_mapManager->getMapData()->defaultRoomColor = baseDlg->cmdDefaultRoom->color();
	m_mapManager->getMapData()->lowerRoomColor = baseDlg->cmdLowerRoom->color();
	m_mapManager->getMapData()->lowerPathColor = baseDlg->cmdLowerPath->color();
	m_mapManager->getMapData()->lowerTextColor = baseDlg->cmdLowerText->color();
	m_mapManager->getMapData()->lowerZoneColor = baseDlg->cmdLowerZone->color();
	m_mapManager->getMapData()->higherRoomColor = baseDlg->cmdUpperRoom->color();
	m_mapManager->getMapData()->higherPathColor = baseDlg->cmdUpperPath->color();
	m_mapManager->getMapData()->higherTextColor = baseDlg->cmdUpperText->color();
	m_mapManager->getMapData()->higherZoneColor = baseDlg->cmdUpperZone->color();
	m_mapManager->getMapData()->backgroundColor = baseDlg->cmdBackground->color();
	m_mapManager->getMapData()->gridColor = baseDlg->cmdGrid->color();
}
