/***************************************************************************
                               dlgmapdirections.cpp
                             -------------------
    begin                : Tue Nov 19 2002
    copyright            : (C) 2002 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgmapdirections.h"

#include <qlineedit.h>

#include "dlgmapdirectionsbase.h"
#include "../cmapmanager.h"



DlgMapDirections::DlgMapDirections(CMapManager *mapManager,QString group,QWidget *parent, const char *name) :  KmudSetupPane(KmudSetupPane::GLOBAL,group,parent,name)
{
	m_mapManager = mapManager;

	addBaseDialog(new DlgMapDirectionsBase(this,name));

	DlgMapDirectionsBase *baseDlg = (DlgMapDirectionsBase *)getBaseDialog();

	baseDlg->m_txtNorthLong->setText(m_mapManager->getMapData()->directions[NORTH]);
	baseDlg->m_txtNorthEastLong->setText(m_mapManager->getMapData()->directions[NORTHEAST]);
	baseDlg->m_txtEastLong->setText(m_mapManager->getMapData()->directions[EAST]);
	baseDlg->m_txtSouthEastLong->setText(m_mapManager->getMapData()->directions[SOUTHEAST]);
	baseDlg->m_txtSouthLong->setText(m_mapManager->getMapData()->directions[SOUTH]);
	baseDlg->m_txtSouthWestLong->setText(m_mapManager->getMapData()->directions[SOUTHWEST]);
	baseDlg->m_txtWestLong->setText(m_mapManager->getMapData()->directions[WEST]);
	baseDlg->m_txtNorthWestLong->setText(m_mapManager->getMapData()->directions[NORTHWEST]);
	baseDlg->m_txtUpLong->setText(m_mapManager->getMapData()->directions[UP]);
	baseDlg->m_txtDownLong->setText(m_mapManager->getMapData()->directions[DOWN]);

	baseDlg->m_txtNorthShort->setText(m_mapManager->getMapData()->directions[NORTH+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtNorthEastShort->setText(m_mapManager->getMapData()->directions[NORTHEAST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtEastShort->setText(m_mapManager->getMapData()->directions[EAST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtSouthEastShort->setText(m_mapManager->getMapData()->directions[SOUTHEAST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtSouthShort->setText(m_mapManager->getMapData()->directions[SOUTH+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtSouthWestShort->setText(m_mapManager->getMapData()->directions[SOUTHWEST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtWestShort->setText(m_mapManager->getMapData()->directions[WEST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtNorthWestShort->setText(m_mapManager->getMapData()->directions[NORTHWEST+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtUpShort->setText(m_mapManager->getMapData()->directions[UP+(NUM_DIRECTIONS/2)]);
	baseDlg->m_txtDownShort->setText(m_mapManager->getMapData()->directions[DOWN+(NUM_DIRECTIONS/2)]);

}

DlgMapDirections::~DlgMapDirections()
{
}

/** This slot is called when the delfault/reset button is pressed */
void DlgMapDirections::slotDefaultPressed()
{
	DlgMapDirectionsBase *baseDlg = (DlgMapDirectionsBase *)getBaseDialog();
	
	baseDlg->m_txtNorthLong->setText("north");
	baseDlg->m_txtNorthEastLong->setText("northeast");
	baseDlg->m_txtEastLong->setText("east");
	baseDlg->m_txtSouthEastLong->setText("southeast");
	baseDlg->m_txtSouthLong->setText("south");
	baseDlg->m_txtSouthWestLong->setText("southwest");
	baseDlg->m_txtWestLong->setText("west");
	baseDlg->m_txtNorthWestLong->setText("northwest");
	baseDlg->m_txtUpLong->setText("up");
	baseDlg->m_txtDownLong->setText("down");

	baseDlg->m_txtNorthShort->setText("n");
	baseDlg->m_txtNorthEastShort->setText("ne");
	baseDlg->m_txtEastShort->setText("e");
	baseDlg->m_txtSouthEastShort->setText("se");
	baseDlg->m_txtSouthShort->setText("s");
	baseDlg->m_txtSouthWestShort->setText("sw");
	baseDlg->m_txtWestShort->setText("w");
	baseDlg->m_txtNorthWestShort->setText("nw");
	baseDlg->m_txtUpShort->setText("u");
	baseDlg->m_txtDownShort->setText("d");
}

/** This slot is called when the cancel button is pressed */
void DlgMapDirections::slotCancelPressed()
{
}

/** This slot is called when the OK button is pressed */
void DlgMapDirections::slotOkPressed()
{
	DlgMapDirectionsBase *baseDlg = (DlgMapDirectionsBase *)getBaseDialog();
	
	m_mapManager->getMapData()->directions[NORTH] = baseDlg->m_txtNorthLong->text();
	m_mapManager->getMapData()->directions[NORTHEAST] = baseDlg->m_txtNorthEastLong->text();
	m_mapManager->getMapData()->directions[EAST] = baseDlg->m_txtEastLong->text();
	m_mapManager->getMapData()->directions[SOUTHEAST] = baseDlg->m_txtSouthEastLong->text();
	m_mapManager->getMapData()->directions[SOUTH] = baseDlg->m_txtSouthLong->text();
	m_mapManager->getMapData()->directions[SOUTHWEST] = baseDlg->m_txtSouthWestLong->text();
	m_mapManager->getMapData()->directions[WEST] = baseDlg->m_txtWestLong->text();
	m_mapManager->getMapData()->directions[NORTHWEST] = baseDlg->m_txtNorthWestLong->text();
	m_mapManager->getMapData()->directions[UP] = baseDlg->m_txtUpLong->text();
	m_mapManager->getMapData()->directions[DOWN] = baseDlg->m_txtDownLong->text();

	m_mapManager->getMapData()->directions[NORTH+(NUM_DIRECTIONS/2)] = baseDlg->m_txtNorthShort->text();
	m_mapManager->getMapData()->directions[NORTHEAST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtNorthEastShort->text();
	m_mapManager->getMapData()->directions[EAST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtEastShort->text();
	m_mapManager->getMapData()->directions[SOUTHEAST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtSouthEastShort->text();
	m_mapManager->getMapData()->directions[SOUTH+(NUM_DIRECTIONS/2)] = baseDlg->m_txtSouthShort->text();
	m_mapManager->getMapData()->directions[SOUTHWEST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtSouthWestShort->text();
	m_mapManager->getMapData()->directions[WEST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtWestShort->text();
	m_mapManager->getMapData()->directions[NORTHWEST+(NUM_DIRECTIONS/2)] = baseDlg->m_txtNorthWestShort->text();
	m_mapManager->getMapData()->directions[UP+(NUM_DIRECTIONS/2)] = baseDlg->m_txtUpShort->text();
	m_mapManager->getMapData()->directions[DOWN+(NUM_DIRECTIONS/2)] = baseDlg->m_txtDownShort->text();
}
