/***************************************************************************
                            kmudmapperfactory.cpp
                             -------------------
    begin                : Sat Apr 28 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kinstance.h>

#include "kmudmapperfactory.h"
#include "cmapmanager.h"

extern "C"
{
	void* init_libkmudmapper()
	{
		return new KmudMapperFactory;
	}
};


KmudMapperFactory::KmudMapperFactory(QObject* parent, const char* name)
	: KmudFactory(parent, name)
{
}

KmudMapperFactory::~KmudMapperFactory()
{
	delete s_instance;
	s_instance = 0;
}

KmudPart* KmudMapperFactory::createKmudPartObject(KmudAPI* api, QObject*, const QStringList& )
{
	return new CMapManager(api);
}

KInstance* KmudMapperFactory::s_instance = 0;
KInstance* KmudMapperFactory::instance()
{
    if (!s_instance)
        s_instance = new KInstance("kmudmapper");

    return s_instance;
}
