/***************************************************************************
                               cmappluginmovetracker.cpp
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmappluginmovetracker.h"
#include "cmapmovetrackerfactory.h"
#include "cmapviewmovetrackermanager.h"


#include "../../cmapmanager.h"

#include <qiconset.h>


#include <kstddirs.h>

CMapPluginMoveTracker::CMapPluginMoveTracker(CMapManager *manager,QObject *parent, const char *name ) : CMapPluginBase(manager,parent,name)
{
	// setting instance name
	setInstance(CMapMoveTrackerFactory::instance());

	setXMLFile (locate("data", "kmudmapper/plugins/kmudmapper_movetracker.rc"));

	// Create and Add the views to the views list
	viewList.append(new CMapViewMoveTrackerManager(actionCollection(),manager,parent,name));	

	actionCollection()->action("viewMoveTracker")->setEnabled(false);
}

CMapPluginMoveTracker::~CMapPluginMoveTracker()
{
}

/** This is called when the character or mud profiles change */
void CMapPluginMoveTracker::profileChanged(void)
{
	actionCollection()->action("viewMoveTracker")->setEnabled(true);
}
