/***************************************************************************
                               cmapspeedwalkfactory.cpp
                             -------------------
    begin                : Tue May 1 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmapspeedwalkfactory.h"

#include <klocale.h>
#include <kstddirs.h>
#include <kinstance.h>
#include <kaboutdata.h>

#include <kmuddebug.h>

#include "../../cmapmanager.h"

#include "cmappluginspeedwalk.h"

extern "C"
{
	void* init_libkmudmapper_speedwalk()
	{
		return new CMapSpeedwalkFactory;
	}
};

KInstance* CMapSpeedwalkFactory::s_instance = 0L;
KAboutData* CMapSpeedwalkFactory::s_about = 0L;

CMapSpeedwalkFactory::CMapSpeedwalkFactory(QObject* parent, const char* name) : CMapPluginFactory( parent, name )
{
}

CMapSpeedwalkFactory::~CMapSpeedwalkFactory()
{
	delete s_instance;
	s_instance = 0L;
	delete s_about;
}

KInstance* CMapSpeedwalkFactory::instance()
{
	if( !s_instance )
	{
		s_about = new KAboutData( "kmudmapperspeedwalkplugin",I18N_NOOP( "KMudMapper Speedwalk List Plugin" ), "1.0" );
		s_instance = new KInstance( s_about );
	}
	return s_instance;
}

CMapPluginBase *CMapSpeedwalkFactory::createPluginInstance(CMapManager* manager, QObject* parent)
{
	CMapPluginSpeedwalk *plugin = new CMapPluginSpeedwalk(manager,parent,"Speedwalk");
	
	emit objectCreated( plugin );
	
	return plugin;
}

